<?php
// $Id: functions.php,v 1.7 2003/02/20 12:57:01 okazu Exp $
//  ------------------------------------------------------------------------ //
//                XOOPS - PHP Content Management System                      //
//                    Copyright (c) 2000 XOOPS.org                           //
//                       <http://www.xoops.org/>                             //
//  ------------------------------------------------------------------------ //
//  This program is free software; you can redistribute it and/or modify     //
//  it under the terms of the GNU General Public License as published by     //
//  the Free Software Foundation; either version 2 of the License, or        //
//  (at your option) any later version.                                      //
//                                                                           //
//  You may not change or alter any portion of this comment or credits       //
//  of supporting developers from this source code or any supporting         //
//  source code which is considered copyrighted (c) material of the          //
//  original comment or credit authors.                                      //
//                                                                           //
//  This program is distributed in the hope that it will be useful,          //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of           //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            //
//  GNU General Public License for more details.                             //
//                                                                           //
//  You should have received a copy of the GNU General Public License        //
//  along with this program; if not, write to the Free Software              //
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA //
//  ------------------------------------------------------------------------ //


// Ajouts par Niluge_Kiwi
// v 1.4 2006/07/08 17:39:14
// ======================================================================== //
//
//   www.lmdmf.net
//
// kiwiiii@gmail.com
//
// ======================================================================== //
//


/* -----------------------------------------------------------------------------------------
checkAccess()
Checks if the current user accessing the page belongs to one of the $grps, and if not,
sends him where you like. Used in modules.

Useage:
checkAccess(<groups to check against>, <redirect to>, <time>, <error message>);

Example:
checkAccess($groupid, XOOPS_URL . "/", 2, _NOPERM);
checkAccess($groupid, "javascript:history.go(-1)", 2, _NOPERM);
checkAccess($groupid);
checkAccess("1 2 3");

* $groupid is normaly taken from the dbtable of the module in question.
* $groupid can either be an array of numbers or a space delimited string. see: listGroups()
------------------------------------------------------------------------------------------*/
function checkMyDownloadsAccess($groupid,$usersid, $url="index.php", $time="2", $msg=_NOPERM) 
{
	global $xoopsUser;
	
	if (!$xoopsUser) 
	{
		$grps = array(XOOPS_GROUP_ANONYMOUS);
		$uid=null;
	} 
	else 
	{
		$grps = array_merge( $xoopsUser->getGroups(), XOOPS_GROUP_ANONYMOUS);
		$uid = $xoopsUser->getVar('uid');
	}
	
	$groupid = explode(" ", $groupid);
	for ($i=0; $i<count($groupid); $i++) 
	{
		if (@in_array($groupid[$i], $grps))
		{
			$hasAccess="TRUE";
		}
	}
	//Correction bug accs anonyme anonyme
	if ($uid != null)
	{
		$usersid = explode(" ", $usersid);
		for ($i=0; $i<count($usersid); $i++) 
		{
			if ($usersid[$i]==$uid)
			{
				$hasAccess="TRUE";
			}
	
		}
	}
	if (!$hasAccess == "TRUE") 
	{
		if($time == -1) 
		{
			return 0;
		} 
		else 
		{
			redirect_header($url, $time, $msg);
			exit();
		}
	}
 	return 1;
}





//ajouts

function checkGroupNoLimited() 
{

	global $xoopsModuleConfig, $xoopsUser;
	
	//groupe du visiteur
	if (!$xoopsUser) 
	{
		return false;
	} 
	else 
	{
		$grps = array_merge( $xoopsUser->getGroups(), XOOPS_GROUP_ANONYMOUS);
		$uid = $xoopsUser->getVar('uid');
	}
	
	//groupes non limits
	$groupid = $xoopsModuleConfig['groupnolimit'];
	//$groupid = explode(" ", $groupid);
	
	//pour chaque groupe non limit
	for ($i=0; $i<count($groupid); $i++) 
	{
		//si groupe visiteur correspond au groupe autoris : return true
		if (@in_array($groupid[$i], $grps) )
		{
			return true;
		}
	}
	
	//si groupe visiteur limit : return false
	return false;
}

function checkMyDownloadsLimiteAff($cid,$url) 
{

//fonction faite pour l'affichage : 
//si les dl sont limits, si la catgorie est limite, et si l'url est sur l'host, alors on affiche "limit" (1)
//						  sinon on affiche "non limit" (0)
//si les dl ne sont pas limits ou que le membre apartient a un groupe non limit on affiche rien (2)

	global $xoopsModuleConfig;
	
	if(!checkGroupNoLimited())
	{
		if ($xoopsModuleConfig['limitdl'] == 1)
		{
			if (checkMyDownloadsCatLimite($cid) && checkMyDownloadsHost($url)) {
				$imglimit = 1;
			}
			else {
				$imglimit = 0;
			}
		}
		else {
			$imglimit = 2;
		}
	}
	else 
	{
		$imglimit = 2;
	}
	return $imglimit;
}

function checkMyDownloadsDesactive() 
{

//fonction qui retourne true si les dl sont dsactivs

	global $xoopsModuleConfig;
	
	if ($xoopsModuleConfig['limitdl'] == 1 && $xoopsModuleConfig['limitnumber'] == 0)
	{
	return true;
	}
	return false;
}

function checkMyDownloadsPermission($groupid, $usersid, $cid = null) 
{

//fonction qui regarde si lutilisateur a accs au fichier\ la catgorie
//ajout : si les dl sont dsactivs et que la catgorie est limite, alors false

	global $xoopsUser, $xoopsDB;
	
 	if (!empty($cid) && checkMyDownloadsDesactive() && checkMyDownloadsCatLimite($cid))
	{
		return false;
	}
	if (!$xoopsUser) 
	{
		$grps = array(XOOPS_GROUP_ANONYMOUS);
		$uid = null;
	} 
	else 
	{
		$grps = array_merge( $xoopsUser->getGroups(), XOOPS_GROUP_ANONYMOUS);
		$uid = $xoopsUser->getVar('uid');
	}
	$groupid = explode(" ", $groupid);
	for ($i=0; $i<count($groupid); $i++) 
	{
		if (@in_array($groupid[$i], $grps) )
		{
			return true;
		}
	}
	//Correction bug accs anonyme anonyme
	if ($uid != null)
	{
		$usersid = explode(" ", $usersid);
		for ($i=0; $i<count($usersid); $i++) 
		{
			if ($usersid[$i]==$uid)
			{
				return true;
			}
		}
	}
	return false;
 
}


function findDownloadPath($url) {
	//Renvoie le chemin absolu du fichier $url
	$path = XOOPS_ROOT_PATH . substr($url, strlen(XOOPS_URL));
	return($path);

}


function mde_collapsableBar(){
	//Fonction rcupre sur le module smartmedia
    ?>
	<script type="text/javascript"><!--
	function goto_URL(object)
	{
		window.location.href = object.options[object.selectedIndex].value;
	}
	
	function toggle(id)
	{
		if (document.getElementById) { obj = document.getElementById(id); }
		if (document.all) { obj = document.all[id]; }
		if (document.layers) { obj = document.layers[id]; }
		if (obj) {
			if (obj.style.display == "none") {
				obj.style.display = "";
			} else {
				obj.style.display = "none";
			}
		}
		return false;
	}
	
	var iconClose = new Image();
	iconClose.src = '../images/close12.gif';
	var iconOpen = new Image();
	iconOpen.src = '../images/open12.gif';
	
	function toggleIcon ( iconName )
	{
		if ( document.images[iconName].src == window.iconOpen.src ) {
			document.images[iconName].src = window.iconClose.src;
		} else if ( document.images[iconName].src == window.iconClose.src ) {
			document.images[iconName].src = window.iconOpen.src;
		}
		return;
	}
	
	//-->
	</script>
	<?php
}

function date_from_logs($date, $sep){
	//fonction qui retourne un tableau contenant numro du jour dans le mois, numro du mois, numro de l'anne

	$date2 = array(
		"mday" => substr($date, 6, 2),
		"mon" => substr($date, 4, 2),
		"year" => substr($date, 0, 4)
	); 
	
	if(isset($sep)) return implode($sep, $date2);
	else return $date2;
	
}

function graph_stats($datemin, $datemax) {
	//fonction qui crer un graph des stats du $mois
	
	global $xoopsDB;
	
	$date = getdate();
	if(empty($datemin) && empty($datemax)) {
		if ($date["mon"] < 10) $date["mon"] = "0".$date["mon"];
		$datemin = $date["year"].$date["mon"]."01";
		$datemax = $date["year"].$date["mon"]."31";
	}
	elseif(empty($datemax)) $datemax = $date["year"].$date["mon"].$date["mday"];
	elseif(empty($datemin)) $datemax = "00000000";
	
	echo "<div>". _MD_STATS_PERIODE ." :&nbsp;<b>".date_from_logs($datemin,"/")."&nbsp;&nbsp;-&nbsp;&nbsp;".date_from_logs($datemax,"/")."</b></div>";
	echo "<p>&nbsp;</p>";
	
	//On rcupre les stats globales
	$result = $xoopsDB->query( "SELECT date, count, size, countuid FROM " . $xoopsDB->prefix( "mydownloads_totalstats" ) . " WHERE `date` >= ".$datemin." AND `date` <= ".$datemax."" );
	while(list( $dateDl, $nbreDl, $volumeDl, $nbreMembers ) = $xoopsDB->fetchRow( $result )) {
		$date2 = date_from_logs($dateDl);
		echo "<div>" . _MD_STATS_DATE . " :<b>&nbsp;" . implode("/", $date2) . "</b></div>";
		echo "<div>" . _MD_STATS_NBREUSER . " :<b>&nbsp;" . $nbreMembers . "</b></div>";
		echo "<div>" . _MD_STATS_NBREDL . " :<b>&nbsp;" . $nbreDl . "</b></div>";
		echo "<div>" . _MD_STATS_VOLUMEDL . " :<b>&nbsp;" . PrettySize($volumeDl) . "</b></div>";
		echo "<p>&nbsp;</p>";
	}
	
	//On rcupre les stats du jour
	$result = $xoopsDB->query( "SELECT COUNT(*), SUM(count), SUM(size) FROM " . $xoopsDB->prefix( "mydownloads_count" ) . " WHERE uid > -1" );
	list( $nbreMembers, $nbreDl, $volumeDl ) = $xoopsDB->fetchRow( $result );
	if ($totalnbre == 0) {
		$totalvolume = 0;
		$totalnbre = 0;
	}
	if ($nbreMembers == 0) {
		$nbreDl = 0;
		$volumeDl = 0;
	}
	
	echo "<div>" . _MD_STATS_DATE . " :<b>&nbsp;" . $date["mday"] ."/". $date["mon"] ."/". $date["year"] ."&nbsp;(". _MD_STATS_TODAY . ")</b></div>";
	echo "<div>" . _MD_STATS_NBREUSER . " :<b>&nbsp;" . $nbreMembers . "</b></div>";
	echo "<div>" . _MD_STATS_NBREDL . " :<b>&nbsp;" . $nbreDl . "</b></div>";
	echo "<div>" . _MD_STATS_VOLUMEDL . " :<b>&nbsp;" . PrettySize($volumeDl) . "</b></div>";
	echo "<p>&nbsp;</p>";
	
	
}

//fin ajouts


/* -----------------------------------------------------------------------------------------
saveMyDownloadsAccess()
Makes sure $groupid is a space delimited string and not an array, before saving to database.
Used in admin interface.

Useage:
$groupid = saveMyDownloadsAccess($groupid);
------------------------------------------------------------------------------------------*/
function saveMyDownloadsAccess($grps) 
{
	if ( is_array($grps) ) { $grps = implode(" ", $grps); }
	return($grps);
}





function mainheader($mainlink=1) {
		echo "<br /><br /><p><a href=\"".XOOPS_URL."/modules/mydownloads/index.php\"><img src=\"".XOOPS_URL."/modules/mydownloads/images/logo-en.gif\" border=\"0\" alt\"\" /></a></p><br /><br />";
}

function newdownloadgraphic($time, $status) {
	$count = 7;
	$new = '';
	$startdate = (time()-(86400 * $count));
		if ($startdate < $time) {
		if($status==1){
			$new = "&nbsp;<img src=\"".XOOPS_URL."/modules/mydownloads/images/newred.gif\" alt=\""._MD_NEWTHISWEEK."\" />";
		}elseif($status==2){
			$new = "&nbsp;<img src=\"".XOOPS_URL."/modules/mydownloads/images/update.gif\" alt=\""._MD_UPTHISWEEK."\" />";
		}
	}
	return $new;
}

function popgraphic($hits) {
	global $xoopsModuleConfig;
	if ($hits >= $xoopsModuleConfig['popular']) {
		return "&nbsp;<img src =\"".XOOPS_URL."/modules/mydownloads/images/pop.gif\" alt=\""._MD_POPULAR."\" />";
	}
	return '';
}
//Reusable Link Sorting Functions
function convertorderbyin($orderby) {
	switch (trim($orderby)) {
	case "titleA":
		$orderby = "title ASC";
		break;
	case "dateA":
		$orderby = "date ASC";
		break;
	case "hitsA":
		$orderby = "hits ASC";
		break;
	case "ratingA":
		$orderby = "rating ASC";
		break;
	case "titleD":
		$orderby = "title DESC";
		break;
	case "hitsD":
		$orderby = "hits DESC";
		break;
	case "ratingD":
		$orderby = "rating DESC";
		break;
	case"dateD":
	default:
		$orderby = "date DESC";
		break;
	}
	return $orderby;
}
function convertorderbytrans($orderby) {
	if ($orderby == "hits ASC")   $orderbyTrans = _MD_POPULARITYLTOM;
	if ($orderby == "hits DESC")    $orderbyTrans = _MD_POPULARITYMTOL;
	if ($orderby == "title ASC")    $orderbyTrans = _MD_TITLEATOZ;
	if ($orderby == "title DESC")   $orderbyTrans = _MD_TITLEZTOA;
	if ($orderby == "date ASC") $orderbyTrans = _MD_DATEOLD;
	if ($orderby == "date DESC")   $orderbyTrans = _MD_DATENEW;
	if ($orderby == "rating ASC")  $orderbyTrans = _MD_RATINGLTOH;
	if ($orderby == "rating DESC") $orderbyTrans = _MD_RATINGHTOL;
	return $orderbyTrans;
}
function convertorderbyout($orderby) {
	if ($orderby == "title ASC")            $orderby = "titleA";
	if ($orderby == "date ASC")            $orderby = "dateA";
	if ($orderby == "hits ASC")          $orderby = "hitsA";
	if ($orderby == "rating ASC")        $orderby = "ratingA";
	if ($orderby == "title DESC")              $orderby = "titleD";
	if ($orderby == "date DESC")            $orderby = "dateD";
	if ($orderby == "hits DESC")          $orderby = "hitsD";
	if ($orderby == "rating DESC")        $orderby = "ratingD";
	return $orderby;
}

function PrettySize($size) {
	$mb = 1024*1024;
	if ( $size > $mb ) {
		$mysize = sprintf ("%01.2f",$size/$mb) . _MD_MBYTES;
	}
	elseif ( $size >= 1024 ) {
		$mysize = sprintf ("%01.2f",$size/1024) . _MD_KBYTES;
	}
	else {
	    $mysize = sprintf(_MD_NUMBYTES,$size);
	}
	return $mysize;
}

//updates rating data in itemtable for a given item
function updaterating($sel_id){
	global $xoopsDB;
	$query = "select rating FROM ".$xoopsDB->prefix("mydownloads_votedata")." WHERE lid = ".$sel_id."";
	$voteresult = $xoopsDB->query($query);
		$votesDB = $xoopsDB->getRowsNum($voteresult);
	$totalrating = 0;
		while(list($rating)=$xoopsDB->fetchRow($voteresult)){
		$totalrating += $rating;
	}
	$finalrating = $totalrating/$votesDB;
	$finalrating = number_format($finalrating, 4);
	$sql = sprintf("UPDATE %s SET rating = %u, votes = %u WHERE lid = %u", $xoopsDB->prefix("mydownloads_downloads"), $finalrating, $votesDB, $sel_id);
	$xoopsDB->query($sql);
}

//returns the total number of items in items table that are accociated with a given table $table id
function getTotalItems($sel_id, $status=""){
	global $xoopsDB, $mytree;
	$count = 0;
	$arr = array();
	$query = "select count(*) from ".$xoopsDB->prefix("mydownloads_downloads")." where cid=".$sel_id."";
	if($status!=""){
		$query .= " and status>=$status";
	}
	$result = $xoopsDB->query($query);
	list($thing) = $xoopsDB->fetchRow($result);
	$count = $thing;
	$arr = $mytree->getAllChildId($sel_id);
	$size = count($arr);
	for($i=0;$i<$size;$i++){
		$query2 = "select count(*) from ".$xoopsDB->prefix("mydownloads_downloads")." where cid=".$arr[$i]."";
		if($status!=""){
			$query2 .= " and status>=$status";
		}
		$result2 = $xoopsDB->query($query2);
		list($thing) = $xoopsDB->fetchRow($result2);
		$count += $thing;
	}
	return $count;
}

?>
