#
# Table structure for table `mydownloads_broken`
#

CREATE TABLE mydownloads_broken (
  reportid int(5) NOT NULL auto_increment,
  lid int(11) NOT NULL default '0',
  sender int(11) NOT NULL default '0',
  ip varchar(20) NOT NULL default '',
  PRIMARY KEY  (reportid),
  KEY lid (lid),
  KEY sender (sender),
  KEY ip (ip)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Table structure for table `mydownloads_cat`
#

CREATE TABLE mydownloads_cat (
  cid int(5) unsigned NOT NULL auto_increment,
  pid int(5) unsigned NOT NULL default '0',
  groupid varchar(100)NOT NULL default '1',
  usersid longtext NOT NULL,
  title varchar(50) NOT NULL default '',
  imgurl varchar(150) NOT NULL default '',
  limited tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (cid),
  KEY pid (pid)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Table structure for table `mydownloads_downloads`
#

CREATE TABLE mydownloads_downloads (
  lid int(11) unsigned NOT NULL auto_increment,
  cid int(5) unsigned NOT NULL default '0',
  groupid varchar(100)NOT NULL default '1',
  usersid longtext NOT NULL,
  title varchar(100) NOT NULL default '',
  url varchar(250) NOT NULL default '',
  homepage varchar(100) NOT NULL default '',
  version varchar(10) NOT NULL default '',
  size int(8) NOT NULL default '0',
  platform varchar(50) NOT NULL default '',
  logourl varchar(60) NOT NULL default '',
  submitter int(11) NOT NULL default '0',
  status tinyint(2) NOT NULL default '0',
  date int(10) NOT NULL default '0',
  hits int(11) unsigned NOT NULL default '0',
  rating double(6,4) NOT NULL default '0.0000',
  votes int(11) unsigned NOT NULL default '0',
  comments int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (lid),
  KEY cid (cid),
  KEY status (status),
  KEY title (title(40))
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Table structure for table `mydownloads_mod`
#

CREATE TABLE mydownloads_mod (
  requestid int(11) unsigned NOT NULL auto_increment,
  lid int(11) unsigned NOT NULL default '0',
  cid int(5) unsigned NOT NULL default '0',
  groupid varchar(100)NOT NULL default '',
  usersid longtext NOT NULL,
  title varchar(100) NOT NULL default '',
  url varchar(250) NOT NULL default '',
  homepage varchar(100) NOT NULL default '',
  version varchar(10) NOT NULL default '',
  size int(8) NOT NULL default '0',
  platform varchar(50) NOT NULL default '',
  logourl varchar(60) NOT NULL default '',
  description text NOT NULL,
  modifysubmitter int(11) NOT NULL default '0',
  PRIMARY KEY  (requestid)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Table structure for table `mydownloads_text`
#

CREATE TABLE mydownloads_text (
  lid int(11) unsigned NOT NULL default '0',
  description text NOT NULL,
  KEY lid (lid)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Table structure for table `mydownloads_votedata`
#

CREATE TABLE mydownloads_votedata (
  ratingid int(11) unsigned NOT NULL auto_increment,
  lid int(11) unsigned NOT NULL default '0',
  ratinguser int(11) NOT NULL default '0',
  rating tinyint(3) unsigned NOT NULL default '0',
  ratinghostname varchar(60) NOT NULL default '',
  ratingtimestamp int(10) NOT NULL default '0',
  PRIMARY KEY  (ratingid),
  KEY ratinguser (ratinguser),
  KEY ratinghostname (ratinghostname),
  KEY lid (lid)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Table structure for table `mydownloads_ip`
#

CREATE TABLE mydownloads_ip (
 ip VARCHAR( 15 ) default '0.0.0.0' NOT NULL ,
 uid INT( 5 ) DEFAULT '0' NOT NULL ,
 KEY ip (ip) 
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Table structure for table `mydownloads_count`
#

CREATE TABLE `mydownloads_count` (
 uid INT(5) DEFAULT '0' NOT NULL ,
 count TINYINT(3) DEFAULT '0' NOT NULL ,
 size INT(15) NOT NULL default '0' NOT NULL ,
 KEY uid (uid) 
) TYPE=MyISAM;

INSERT INTO `mydownloads_count` ( `uid` , `count` ) 
VALUES ('-3', '20060101');
# --------------------------------------------------------

#
# Table structure for table `mydownloads_stats`
#

CREATE TABLE `mydownloads_stats` (
 uid INT(5) DEFAULT '0' NOT NULL ,
 count INT(5) DEFAULT '0' NOT NULL ,
 size INT(15) NOT NULL default '0' NOT NULL ,
 KEY uid (uid) 
) TYPE=MyISAM;
# --------------------------------------------------------
#
# Table structure for table `mydownloads_totalstats`
#

CREATE TABLE `mydownloads_totalstats` (
 id INT(11) unsigned NOT NULL auto_increment,
 date INT(8) NOT NULL ,
 count INT(5) DEFAULT '0' NOT NULL ,
 size INT(15) DEFAULT '0' NOT NULL ,
 countuid tinyint(4) DEFAULT '0' NOT NULL ,
 KEY ( `id` )
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Table structure for table `mydownloads_multic`
#

CREATE TABLE `mydownloads_multic` (
 uid INT( 5 ) DEFAULT '0' NOT NULL ,
 uid2 INT( 5 ) DEFAULT '0' NOT NULL ,
 actif TINYINT( 1 ) DEFAULT '0' NOT NULL ,
 KEY uid (uid)
) TYPE=MyISAM;
